﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace WebApplication1MVC.Models
{
    public class Products
    {
        private List<Product> ProductsList;

        public void UpdateProduct(Product prod)
        {
            foreach (Product p in ProductsList)
            {
                if (p.ProductID == prod.ProductID)
                {
                    p.Name = prod.Name;
                    p.ProductNumber = prod.ProductNumber;
                    break;
                }
            }
        }

        public void AddProduct(Product prod)
        {
            ProductsList.Add(prod);
        }

        public void DeleteProduct(int ProductId)
        {
            foreach (Product p in ProductsList)
            {
                if (p.ProductID == ProductId)
                {
                    ProductsList.Remove(p);
                    break;
                }
            }
        }

        public IQueryable<Product> GetProductList()
        {
            return ProductsList.AsQueryable<Product>();
        }

        public IQueryable<Product> GetPartialProductList(string page, string pageSize)
        {
            int pageNum = Convert.ToInt32(page);
            int pageLen = Convert.ToInt32(pageSize);

            return ProductsList.Skip(pageNum * pageLen).Take(pageLen).AsQueryable<Product>();
        }

        public Products()
        {
            //List<Product> 
            ProductsList = new List<Product>();

            for (int i = 0; i < 100; i++)
            {
                Product product = new Product();
                product.ProductID = i;
                product.Name = string.Format("Name {0}", i);
                product.ProductNumber = string.Format("Product Num {0}", i);

                ProductsList.Add(product);
            }
        }

        public class Product
        {
            public int ProductID { get; set; }
            public string Name { get; set; }
            public string ProductNumber { get; set; }
        }
    }
}